declare type Key = string | symbol;
export interface TaggedError<T extends Key> extends Error {
    type: T;
    name: string;
    reason?: Error;
}
export declare const TaggedError: <T extends string | symbol>(type: T, message?: string | undefined) => TaggedError<T>;
export declare const ofError: <T extends string | symbol>(type: T, reason: Error, message?: string | undefined) => TaggedError<T>;
export declare const ofUnknown: <T extends string | symbol>(type: T, reason: unknown, message?: string | undefined) => TaggedError<T>;
export declare const map: <A extends Key, B extends Key>(fun: (a: A) => B) => (fa: TaggedError<A>) => TaggedError<B>;
export {};
