import { Transaction } from '@google-cloud/firestore';
import { TaskEither } from 'fp-ts/lib/TaskEither';
import { FirestoreErrorType } from './FirestoreError';
import { TaggedError } from './TaggedError';
declare type Key = string | symbol;
interface Tx<E extends Key, S extends Record<string, unknown>> {
    bind: <N extends string, A, E1 extends Key>(name: Exclude<N, keyof S>, maTx: (tx: Transaction) => TaskEither<TaggedError<E1>, A>) => Tx<E | E1, S & {
        [K in N]: A;
    }>;
    bindL: <N extends string, A, E1 extends Key>(name: Exclude<N, keyof S>, f: (s: S) => (tx: Transaction) => TaskEither<TaggedError<E1>, A>) => Tx<E | E1, S & {
        [K in N]: A;
    }>;
    do: <E1 extends Key>(maTx: (tx: Transaction) => TaskEither<TaggedError<E1>, unknown>) => Tx<E | E1, S>;
    doL: <E1 extends Key>(f: (s: S) => (tx: Transaction) => TaskEither<TaggedError<E1>, unknown>) => Tx<E | E1, S>;
    let: <N extends string, A>(name: Exclude<N, keyof S>, a: A) => Tx<E, S & {
        [K in N]: A;
    }>;
    letL: <N extends string, A>(name: Exclude<N, keyof S>, f: (s: S) => A) => Tx<E, S & {
        [K in N]: A;
    }>;
    return: <A>(f: (s: S) => A) => TaskEither<TaggedError<E>, A>;
    done: () => TaskEither<TaggedError<E>, S>;
}
declare const empty: {};
export declare function Tx<E extends Key = FirestoreErrorType, S extends Record<string, unknown> = typeof empty>(tx: Transaction, init: S): Tx<E, S>;
export {};
