export declare type LessThan<E extends Record<string, unknown>, K extends keyof E = keyof E> = {
    _tag: '<';
    key: K;
    value: E[K];
};
export declare const LessThan: <E extends Record<string, unknown>, K extends keyof E = keyof E>(key: K, value: E[K]) => LessThan<E, keyof E>;
export declare type LessOrEqual<E extends Record<string, unknown>, K extends keyof E = keyof E> = {
    _tag: '<=';
    key: K;
    value: E[K];
};
export declare const LessOrEqual: <E extends Record<string, unknown>, K extends keyof E = keyof E>(key: K, value: E[K]) => LessOrEqual<E, keyof E>;
export declare type Equal<E extends Record<string, unknown>, K extends keyof E = keyof E> = {
    _tag: '==';
    key: K;
    value: E[K];
};
export declare const Equal: <E extends Record<string, unknown>, K extends keyof E = keyof E>(key: K, value: E[K]) => Equal<E, keyof E>;
export declare type GreaterOrEqual<E extends Record<string, unknown>, K extends keyof E = keyof E> = {
    _tag: '>=';
    key: K;
    value: E[K];
};
export declare const GreaterOrEqual: <E extends Record<string, unknown>, K extends keyof E = keyof E>(key: K, value: E[K]) => GreaterOrEqual<E, keyof E>;
export declare type GreaterThan<E extends Record<string, unknown>, K extends keyof E = keyof E> = {
    _tag: '>';
    key: K;
    value: E[K];
};
export declare const GreaterThan: <E extends Record<string, unknown>, K extends keyof E = keyof E>(key: K, value: E[K]) => GreaterThan<E, keyof E>;
export declare type In<E extends Record<string, unknown>, K extends keyof E = keyof E> = {
    _tag: 'in';
    key: K;
    values: E[K][];
};
export declare const In: <E extends Record<string, unknown>, K extends keyof E = keyof E>(key: K, values: E[K][]) => In<E, K>;
export declare type Where<E extends Record<string, unknown>, K extends keyof E = keyof E> = LessThan<E, K> | LessOrEqual<E, K> | Equal<E, K> | GreaterOrEqual<E, K> | GreaterThan<E, K> | In<E, K>;
